### Method

# EDataServer OAuth2Service receive_and_store_token_sync

since: 3.28

#### Declaration [src]

    gboolean
    e_oauth2_service_receive_and_store_token_sync (
      EOAuth2Service* service,
      ESource* source,
      const gchar* authorization_code,
      EOAuth2ServiceRefSourceFunc ref_source,
      gpointer ref_source_user_data,
      GCancellable* cancellable,
      GError** error
    )

#### Description [src]

Queries `service` at `e_oauth2_service_get_refresh_uri()` with a request to obtain a new access token, associated with the given `authorization_code` and stores it into the secret store on success.

Available since: 3.28

#### Parameters

`source`

  Type: `ESource`

  An `ESource`.

  The data is owned by the caller of the method.

`authorization_code`

  Type: `const gchar*`

  Authorization code provided by the server.

  The data is owned by the caller of the method.
  The value is a NUL terminated UTF-8 string.

`ref_source`

  Type: `EOAuth2ServiceRefSourceFunc`

  An `EOAuth2ServiceRefSourceFunc` function to obtain an `ESource`.

`ref_source_user_data`

  Type: `gpointer`

  User data for `ref_source`.

  The argument can be `NULL`.
  The data is owned by the caller of the method.

`cancellable`

  Type: `GCancellable`

  Optional `GCancellable` object, or `NULL`.

  The argument can be `NULL`.
  The data is owned by the caller of the method.

`error`

  Type: `GError **`

  The return location for a recoverable error.

  The argument can be `NULL`.
  If the return location is not `NULL`, then you must initialize it to a `NULL` `GError*`.
  The argument will be left initialized to `NULL` by the method if there are no errors.
  In case of error, the argument will be set to a newly allocated `GError`; the caller will take ownership of the data, and be responsible for freeing it.

#### Return value

Type: `gboolean`

Whether succeeded.